; DCF77-MODUL (Samlingverfahren)				
; Bernhard.Erfurt@gmx.de						
; 09/2012										
;												
; 16 MHz										
; 6xLED(7SEGMENT)								

; - kurz nach Programmstart wird ein LED Test durchgefhrt			
; - Anzeige Konfiguration "c0---0" DCF signal wird nicht invertiert	
; - Anzeige Konfiguration "c0---1" DCF signal wird invertiert		
; - Anzeige interner DCF-ZEIGER z.B. "----12" bis DCF-Protokoll korrekt empfangen wurde						

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> (s.Anschlussbelegung)					
; PB1 ==> (s.Anschlussbelegung)					
; PB2 ==> (s.Anschlussbelegung)					
; PB3 ==> (s.Anschlussbelegung)					
; PB4 ==> (s.Anschlussbelegung)					
; PB5 ==> (s.Anschlussbelegung)					
; PB6 ==> Quarz	16MHz							
; PB7 ==> Quarz	16MHz							
;												
; PC0 ==> 										
; PC1 ==> DCF invertieren 						
; PC2 ==> DCF-EINGANG							
; PC3 ==> LED DCF-GRN (DCF gltig)				
; PC4 ==> LED DCF-GELB (DCF Eingangssignal)		
; PC5 ==> LED DCF-ROT  (Uhr heute noch nicht gestellt)	
;												
; PD0 ==> (A-s.Anschlussbelegung)				
; PD1 ==> (B-s.Anschlussbelegung)				
; PD2 ==> (C-s.Anschlussbelegung)				
; PD3 ==> (D-s.Anschlussbelegung)				
; PD4 ==> (E-s.Anschlussbelegung)				
; PD5 ==> (F-s.Anschlussbelegung)				
; PD6 ==> (G-s.Anschlussbelegung)				
; PD7 ==> (P-s.Anschlussbelegung)				
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT								=16000000			; 16 MHz	

; TIMER-WERTE									
.equ TIMERWERT0 						=256-250			;(2 hoch 8  minus 250)		bei 16MHz + Vorteiler   64 => 0.001s =1ms	
;.equ TIMERWERT0 						=256-125			;(2 hoch 8  minus 125)		bei  8MHz + Vorteiler   64 => 0.001s =1ms	
; LED (gelb) immer DCF SIGNAL anzeigen			
.equ DCF_LED_IMMER_BLINKEN				= 1
; DCF-PHASE_TIMERWERT							
.equ DCF_PHASE_TIMERWERT				= 6					; (1...10) nach 3 Sekunden Phase schieben
; DCF-PORT										
.equ DCF_PIN_NR							= 2
.equ DCF_DDR							= DDRC
.equ DCF_PORT							= PORTC
.equ DCF_PIN							= PINC
; DCF-SIGNAL-INVERTIEREN						
.equ DCF_INV_PIN_NR						= 1
.equ DCF_INV_DDR						= DDRC
.equ DCF_INV_PORT						= PORTC
.equ DCF_INV_PIN						= PINC
; DCF-ERROR-CODES								
.equ ERROR_DCF_DATENFELD				= 2
.equ ERROR_DCF_MINUTENIMPULS			= 10
.equ ERROR_DCF_NO_ANFANGSBIT			= 12
.equ ERROR_DCF_NO_ZEITINFORMATIONSBIT	= 14
.equ ERROR_DCF_MESZ						= 16
.equ ERROR_DCF_PARITAET_MINUTE			= 100
.equ ERROR_DCF_PARITAET_STUNDE			= 110
.equ ERROR_DCF_PARITAET_DATUM			= 120
.equ ERROR_DCF_STUNDE					= 130
.equ ERROR_DCF_MINUTE					= 140
.equ ERROR_DCF_TAG						= 150
.equ ERROR_DCF_WOCHENTAG				= 160
.equ ERROR_DCF_MONAT					= 170
.equ ERROR_DCF_JAHR						= 180
; LED-DCF-GRUEN									
.equ LED_DCF_GRUEN_PIN_NR			= 3
.equ LED_DCF_GRUEN_DDR				= DDRC
.equ LED_DCF_GRUEN_PORT				= PORTC
; LED-DCF-GELB									
.equ LED_DCF_GELB_PIN_NR			= 4
.equ LED_DCF_GELB_DDR				= DDRC
.equ LED_DCF_GELB_PORT				= PORTC
; LED-DCF-ROT									
.equ LED_DCF_ROT_PIN_NR				= 5
.equ LED_DCF_ROT_DDR				= DDRC
.equ LED_DCF_ROT_PORT				= PORTC
; ZEICHEN-DARSTELLUNG - 7-SEGMENT				
.equ ZAHL_0					=0b00111111	; 0 
.equ ZAHL_1					=0b00000110	; 1 
.equ ZAHL_2					=0b01011011	; 2 
.equ ZAHL_3					=0b01001111	; 3 
.equ ZAHL_4					=0b01100110	; 4 
.equ ZAHL_5					=0b01101101	; 5 
.equ ZAHL_6					=0b01111101	; 6 
.equ ZAHL_7					=0b00000111	; 7 
.equ ZAHL_8					=0b01111111	; 8 
.equ ZAHL_9					=0b01101111	; 9 

.equ ZEICHEN_AUS			=0b00000000	; ''
.equ ZEICHEN_PUNKT			=0b10000000	; . 
.equ ZEICHEN_VOLL			=0b11111111	; 8.
.equ ZEICHEN_MINUS			=0b01000000	; - 

.equ ZEICHEN_A				=0b01110111	; A 
.equ ZEICHEN_B				=0b01111100	; B 
.equ ZEICHEN_C				=0b01011000	; C 
.equ ZEICHEN_D				=0b01011110	; D 
.equ ZEICHEN_E				=0b01111001	; E 
.equ ZEICHEN_F				=0b01110001	; F 
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=0x0060			; 0x0060 START Adresse 		

.equ adr_FREIGABE_PROGRAMM		=0x0060+0		



.equ adr_LED_DIGIT_ZAEHLER		=0x0060+10			; interner Zhler	
.equ adr_LED_BYTE_0				=0x0060+11			; DIGIT				
.equ adr_LED_BYTE_1				=0x0060+12			; DIGIT				
.equ adr_LED_BYTE_2				=0x0060+13			; DIGIT				
.equ adr_LED_BYTE_3				=0x0060+14			; DIGIT				
.equ adr_LED_BYTE_4				=0x0060+15			; DIGIT				
.equ adr_LED_BYTE_5				=0x0060+16			; DIGIT				


.equ adr_ss_VT					=0x0060+20			; Vorteiler	
.equ adr_ss_100					=0x0060+21			; 100-el	
.equ adr_ss						=0x0060+22			; Sekunden	
.equ adr_mm						=0x0060+23			; Minuten	
.equ adr_hh						=0x0060+24			; Stunden	
.equ adr_TAG					=0x0060+25			; Tag		
.equ adr_WOCHENTAG				=0x0060+26			; WochenTag	
.equ adr_MONAT					=0x0060+27			; Monat		
.equ adr_JAHR					=0x0060+28			; Jahr		
.equ adr_MESZ					=0x0060+29			; MESZ		

.equ adr_DCF_mm					=0x0060+100			; Minuten 	aus DCF-Protokoll	
.equ adr_DCF_hh					=0x0060+101			; Stunden 	aus DCF-Protokoll	
.equ adr_DCF_TAG				=0x0060+102			; Tag	 	aus DCF-Protokoll	
.equ adr_DCF_WOCHENTAG			=0x0060+103			; WochenTag aus DCF-Protokoll	
.equ adr_DCF_MONAT				=0x0060+104			; Monat	 	aus DCF-Protokoll	
.equ adr_DCF_JAHR				=0x0060+105			; Jahr	 	 aus DCF-Protokoll	
.equ adr_DCF_MESZ				=0x0060+106			; SOMMERZEIT aus DCF-Protokoll	

.equ adr_DCF_INVERTIERMODUS		=0x0060+110			; 1=EINGANSPEGEL invertieren	

.equ adr_DCF_SAMPLES_ZEIGER		=0x0060+120			; ZEIGER fr SAMPLES			
.equ adr_DCF_SAMPLES_A			=0x0060+121			; SAMPLES_A (100ms)				
.equ adr_DCF_SAMPLES_B			=0x0060+122			; SAMPLES_A (200ms)				
.equ adr_DCF_BIT				=0x0060+124			; DCF-BIT						

.equ adr_DCF_IMPULS_OLD			=0x0060+130
.equ adr_DCF_IMPULS_PHASE		=0x0060+131			; PHASE							
.equ adr_DCF_PHASE_TIMER		=0x0060+132			; TIMER fr PHASE				
.equ adr_DCF_TURBOMODUS			=0x0060+133			; TURBOMODUS bei PROGRAMMSTART 	

.equ adr_DCF_ZEIGER				=0x0060+150			; Zeiger fr DCF-FELD			
.equ adr_DCF_GUELTIG			=0x0060+151			; DCF-Protokoll ist geprft und gltig			
.equ adr_DCF_ERROR_CODE			=0x0060+152			; DCF-ERROR-CODE				

.equ adr_DCF_BEREICH			=0x0060+160	 		; 60 BYTES fr DCF-FELD			

.equ adr_SRAM_CHECK				=0x0060+900			; Programm-Check				


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR  	; Timer1 Overflow Handler           					
rjmp TIM0_OVF			;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; unkorrekten Interrupt								
INTERRUPT_ERROR:
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 ; ROTDCF	
	rcall wait_100ms
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 ; ROTDCF	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM CLEAR										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	
; PORT B initialisieren								
	ldi temp, 0b00000000	
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000
	out DDRD, temp			
; PORT D setzen										
	ldi temp, 0b00000000
	out PORTD, temp				
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; LED_7SEGMENT_INITIALISIERUNG						
	rcall LED_7SEGMENT_INITIALISIERUNG
; Watchdog aktivieren (max. Zeit)					
	rcall Watchdog_aktivieren
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED_TEST											
	rcall LED_TEST
; LED_7SEGMENT_TEST									
	rcall LED_7SEGMENT_TEST
; DCF_INITIALISIERUNG								
	rcall DCF_INITIALISIERUNG
	rcall DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN
; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER aktivieren									
	rcall TIMER_AKTIVIEREN
; Startwerte										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; DATUM				
	STS(adr_TAG),EINS
	STS(adr_MONAT),EINS
	STS(adr_JAHR),NULL
	; DCF-TURBOMODUS	
	STS(adr_DCF_TURBOMODUS),EINS
	; SRAM-CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	rcall PROGRAMM_CHECK

; interrupts freigeben								
	sei
	rcall PROGRAMM_CHECK
	rcall LED_BEGRUESSUNG	
	rcall wait_1s
	rcall LED_SYSTEM_ANZEIGEN_C0
	rcall wait_1s
	rcall wait_1s
	rcall wait_1s
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall PROGRAMM_CHECK
	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp 
	breq LOOP
;-------------------------------------------------------------------------------
	STS(adr_FREIGABE_PROGRAMM),NULL

	rcall MENUE

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; ZEIGER	
	LDS temp,(adr_JAHR)
	tst temp
	breq MENUE_ZEIGER

	; DATUM		
	LDS temp,(adr_ss)
	cpi temp,30
	breq MENUE_DATUM
	cpi temp,31
	breq MENUE_DATUM
	cpi temp,32
	breq MENUE_DATUM
	; ZEIT		
	rjmp MENUE_ZEIT
	ret
MENUE_ZEIT:
	rcall LED_ZEIT_ANZEIGEN
	ret
MENUE_DATUM:
	rcall LED_DATUM_ANZEIGEN
	ret
MENUE_ZEIGER:
	rcall LED_ZEIGER_ANZEIGEN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DCFLED_LED_BELEGUNG6.asm"
.include "DCFLED_LED.asm"

.include "DCFLED_TIMER.asm"
.include "DCFLED_SONSTIGES.asm"
.include "DCFLED_DCF.asm"
.include "DCFLED_16MHZwait.asm"
